/* MB91FV310A Interrupt Initialize */

#include "_fr.h"
#include "extern.h"

void EXTINT_init(void)
{
	IO_ELVR.bit.LBLA4 = 1;		/* HighLevel Detect */
	IO_EIRR.bit.ER4 = 0;		/* Interrupt Request Clear */
	IO_ENIR.bit.EN4 = 1;		/* INT4 Enable : USB Interrupt */

	IO_ICR[4].byte = 0x1c;			/* USB-Func(ExtInt Ch.4) INT level set */

	__set_il(0x1F);				/* ILM = 31 */
	__EI();					/* Interrupt enable */
}
