/* MB91FV310A External-Bus-IF Initialize */

#include "_fr.h"
#include "extern.h"

void IPBUS_init(void)
{
	/* dummy */
	IO_EBUS.IO_ASR0 = 0x0000;
	IO_EBUS.IO_AWR0 = 0x0008;
	IO_EBUS.IO_ACR0.hword = 0x0400;

	/* USB Host */
	IO_EBUS.IO_ASR1 = 0x0005;
	IO_EBUS.IO_AWR1 = 0x1008;
	IO_EBUS.IO_ACR1.hword = 0x0831;

	/* USB Function */
	IO_EBUS.IO_ASR2 = 0x0006;
	IO_EBUS.IO_AWR2 = 0x200d;
	IO_EBUS.IO_ACR2.hword = 0x0420;

	/* OSDC */
	IO_EBUS.IO_ASR3 = 0x0007;
	IO_EBUS.IO_AWR3 = 0x0008;
	IO_EBUS.IO_ACR3.hword = 0x0421;

	IO_EBUS.IO_CSER.byte = 0x0e;	/* CS1X,CS2X,CS3X Enable */

}
