
/****************************************************************
 * FR60 family Monitor Debugger                                 *
 * ALL RIGHTS RESERVED, COPYRIGHT(C) FUJITSU LIMITED 2007       *
 * LICENCED MATERIAL - PROGRAM PROPERTY OF FUJITSU LIMITED      *
 ****************************************************************/

/*------------------------------------------------------------------------------------------*/
/**
 * @file        modFR60_hal.c
 * @brief       j^fobK HAL
 * @par     
 *              FR60t@~Ήj^fobKCvg邽߂HALW[łB
 *              [UVXeɑgݍނ߂ɁÃt@CҏWĂB
 *              Tvł́AzXgʐMUART0,U-TIMER ch.0A
 *              Ԍv16rbg[h^C} ch.0gp܂B
 *
 * @par     荞݃xNge[u̒`
 *              j^fobKŗpӂꂽ荞݃nho^Å荞݂ƁA
 *              [UvOs~vƂȂA̓j^fobKɑJڂ܂B
 *              s~vƂȂꍇ́A[UƎ̃nho^ĂB
 *              AK{ڂ̃nh́Aj^fobKŗ\񂳂Ă܂̂ŁA
 *              Ko^ĂB
 *              j^fobKŗ\񂳂ꂽ荞݂́Aȉ̒ʂłB
 *
 *                  - INT #9
 *                  - INT #10
 *                  - INT #11
 *                  - INT #12
 *                  - INT #255
 *
 */

#include "_fr.h"                    /* I/O`W[gp          */
#include "modFR60.h"                /* j^fobKgݍ       */
#include "extern.h"

/**********
 * ^錾 *
 **********/

typedef unsigned long   ULONG ;     /**< 32rbgȂ   */
typedef unsigned short  USHORT ;    /**< 16rbgȂ   */
typedef unsigned char   UCHAR ;     /**<  8rbgȂ   */
typedef unsigned int    UINT ;      /**< Ȃ           */

/************
 * I *
 ************/

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       v^C}gpB
 * @par     
 *              v^C}gpꍇA`܂B
 *              {W[݂̂ŗLłB
 */

#define USE_MOD_TIMER

/********
 *  *
 ********/

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       [U`̃o[W
 * @par     
 *              [U`̃o[ẄłB
 *              ̗̈́Aj^fobKŎQƂ܂B
 */

const char modFR60_customer_version[] = "Driver Version VxxLxx\0" ;

/********************
 * 荞݃xNg *
 ********************/

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       [hf[^
 * @par     
 *              ZbgV[PXŃtFb`A[hf[^`܂B
@code
 *                [7:3] \
 *                        KOw肷邱ƁB
 *                [2]   ROMA (ROMCl[urbg)
 *                        0 OROM[h
 *                        1 ROM[h
 *                [1:0] WTH1,WTH0(oXwrbg)
 *                        0 WrbgoX/OoX[h
 *                        1 16rbgoX/OoX[h
 *                        2 ݒ֎~@n
 *                        3 VO`bv[h
@endcode
 */

/* #define MODV    0x07000000 */
#define MODV    0x05000000

/*
 *   荞݃xNge[u̒`
 */

#pragma section INTVECT, locate=0xffc00

#pragma defvect modFR60_interrupt_handler                               /* ftHg̃nh             */
#pragma intvect modFR60_reserved_handler                        2       /* VXe\                     */
#pragma intvect modFR60_reserved_handler                        3
#pragma intvect modFR60_reserved_handler                        4
#pragma intvect modFR60_reserved_handler                        5
#pragma intvect modFR60_reserved_handler                        6
#pragma intvect modFR60_coprocessor_error_trap_handler          7       /* RvZbT                     */
#pragma intvect modFR60_coprocessor_absence_exception_handler   8       /* RvZbT                     */
#pragma intvect modFR60_inte_handler                            9       /* j^fobKN(K{)         */
#pragma intvect modFR60_hardware_break                          10      /* ߃u[NO(K{)           */
#pragma intvect modFR60_hardware_break                          11      /* Iyhu[Ngbv(K{) */
#pragma intvect modFR60_trace_handler                           12      /* Xebvg[X(K{)           */
#pragma intvect modFR60_reserved_handler                        13
#pragma intvect modFR60_reserved_instruction_exception_handler  14      /* `ߗO                   */
#pragma intvect modFR60_abort_handler                           15      /* NMIvifj                  */
#pragma intvect modFR60_software_break                          255     /* \tgEFAu[N(K{)       */

extern __interrupt void _start( void ) ;
extern __interrupt void mod_timer_handler( void ) ;

#pragma intvect _start                                          0       /* Zbg                         */
#pragma intvect MODV                                            1       /* [hf[^                     */
#pragma intvect mod_timer_handler                               24      /* 16rbg[h^C}O         */
#pragma intvect modFR60_abort_handler                           27      /* UART0 Mifj               */
                                                                        /* zXg̒fvɂs */
                                                                        /* f邽߂ɁAUART0 M荞 */
                                                                        /* ݂ŁAmodFR60_abort_handler  */
                                                                        /* яo܂B                     */

#pragma intvect  INT4_int	20			/* USB Interrupt(ExtInt Ch.4) */

/*****************
 * zXgʐMI/F *
 *****************/

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       U-TIMER ch.0 (UART0{[[g) UTIMC0WX^ݒl
 * @par     
 *              U-TIMER䃌WX^ݒlB
@code
 *          [7]     UCC1        JEg@B0:=2^n+2,1:=2^n+3
 *          [6:5]   reserved
 *          [4]     UTIE        0B
 *          [3]     UNDR        A_[t[tOB0:NA, 1:A_[t[
 *          [2]     CLKS        0B
 *          [1]     UTST        0:~, 1:
 *          [0]     UTCR        0:^C}NA
@endcode
 */

#define UTIMCDAT        0x02            /* TIMER start  */

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       U-TIMER ch.0 (UART0{[[g) UTIMR0WX^ݒl
 * @par     
 *              U-TIMER[hlB
@code
 *          [15:0]    UTIMR     [hlB
@endcode
 * @par     {[[gvZ@
@code
 *      UCC1=0̂ƂA
 *          bps = f / (2n+2)*16
 *          n = (f/bps/16-2)/2
 *      UCC1=1̂ƂA
 *          bps = f / (2n+3)*16
 *          n = (f/bps/16-3)/2
@endcode
 */

#define UTIMRDAT        15              /* 20MHz,38400bps,UCC1=0    */

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       UART0 SMR0 ݒl
 * @par     
 *              UART0 VA[hWX^
@code
 *          [7:6]   MD          0:񓯊, 1:񓯊}`vZbT, 2:NbN
 *          [5:4]   reserved    1B
 *          [3]     CS0         0:U-TIMER, 1:ONbN
 *          [2:1]   reserved    0B
 *          [0]     reserved
@endcode
 */

#define SMR0DAT         0x30            /* ASync, U-Timer   */

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       UART0 SCR0 ݒl
 * @par     
 *              UART0 VARg[WX^
@code
 *          [7]     PEN         0:peBȂ,1:peB
 *          [6]     P           0:peB,1:peB
 *          [5]     SBL         0:1Xgbvrbg,1:2Xgbvrbg
 *          [4]     CL          0:7rbgf[^,1:8rbgf[^
 *          [3]     A/D         0:f[^t[,1:AhXt[
 *          [2]     REC         0:G[tO(PE,ORE,FRE)̃NA
 *          [1]     RXE         0:M֎~,1:M싖
 *          [0]     TXE         0:M֎~,1:M싖
@endcode
 */

#define SCR0DAT         0x13            /* 8bit,1 stop bit,nonparity,RX enable, TX enable   */

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       UART0 SSR0 ݒl
 * @par     
 *              UART0 VAXe[^XWX^
@code
 *          [7]     PE          1:peBG[
 *          [6]     ORE         1:I[o[G[
 *          [5]     FRE         1:t[~OG[
 *          [4]     RDRF        1:Mf[^
 *          [3]     TDRE        1:Mf[^̏݋
 *          [2]     BDS         0:LSB, 1:MSB
 *          [1]     RIE         1:M荞݋
 *          [0]     TIE         1:M荞݋
@endcode
 */

#define SSR0DAT         0x02            /* RIE=disable,TIE=disable  */


/*------------------------------------------------------------------------------------------*/
/**
 * @brief       UART̏
 * @par     
 *              j^fobKŎgpUART܂B
 * @par
 *              {Tvł́AzXgʐMfoCXƂāAUART0gp܂B
 *              {֐́AVXeNɈxA[UĂяoKv܂B
 *              M荞݂ɂăvOs𒆒f̂ŁAM荞݂͋ƂĂB(ToDo:vmF)
 *
 */

void
mod_uart_init( void )
{
    IO_PORT.IO_PFR1.bit.UART0 = 1 ;
    IO_PORT.IO_PFR1.bit.SCKE0 = 1 ;
    IO_UTIM0        = UTIMRDAT ;
    IO_UTIMC0.byte  = UTIMCDAT ;
    IO_SMR0.byte    = SMR0DAT ;
    IO_SCR0.byte    = SCR0DAT ;
    IO_SSR0.byte    = SSR0DAT ;
    IO_ICR[11].byte = 30 ;
}

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       PM
 * @param[in]   data        Mf[^i[UCHAR^ϐւ̃|C^B
 * @param[out]  *data       Mf[^B
 * @retval      0           IB
 * @retval      -1          I[oG[̓t[~OG[
 * @par     
 *              zXgPM܂B
 *              j^fobKQƂ܂B
 */

int
modFR60_getchr
(
    UCHAR  *data
)
{
    while( IO_SSR0.bit.RDRF == 0 ) ;

    if( IO_SSR0.bit.ORE || IO_SSR0.bit.FRE )
    {
        IO_SCR0.bit.REC = 0 ;
        return -1 ;
    }

    *data = IO_SIDR0 ;
    return 0 ;
}

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       PM
 * @param[in]   data        Mf[^B
 * @par     
 *              zXgɂPM܂B
 *              j^fobKQƂ܂B
 */

void
modFR60_putchr
(
    UCHAR data
)
{
    while( IO_SSR0.bit.TDRE == 0 ) ;
    IO_SIDR0 = data ;
}

/**************
 * v^C} *
 **************/

/* 
 *  @brief      ^C}l
 *  @par    :
 *              ^C}~̃^C}lۑ܂B
 */

USHORT  timer_lo ;

/* 
 *  @brief      ^C}荞݃JEgl
 *  @par    :
 *              ^C}荞݂̐ێ܂B
 */

USHORT  timer_hi ;

/*------------------------------------------------------------------------------------------*/
/**
 *  @brief      SɕKvȃ^C}`bN
 *  @par    :
 *              SɕKvȃ^C}`bNݒ肵܂B
 *              ӃNbN(MHz)/ ŋ߂܂B
 *              Ⴆ΃[h^C}ӃNbN 20MHzłQƐݒ肵ꍇA20/2=10ƂȂ܂B
 */

#define MICRO_TICK  10

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       ^C}荞ݎ
 * @par     
 *              ^C}荞ݎSPʂŐݒ肵܂B
 *              16rbg[h^C}gpꍇATIMER_PERIOD * MICRO_TICK16rbg𒴂Ȃ悤ɐݒ肵܂B
 */

#define TIMER_PERIOD    5000

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       j^fobKp^C}̏
 * @par     
 *              j^fobKŎgp^C}܂B
 *              j^fobḰASx̃^C}QƂ܂B
 *              Tvł́A[h^C}Ogp܂B
 *              {֐́AVXeNɈxA[UĂяoKv܂B
 *              ^C}́A[UvOŝ݂Ɏgp܂B
 */

void
mod_timer_init( void )
{
#ifdef USE_MOD_TIMER
    modFR60_timflag = 1 ;                           /* j^fobK^C}@\ON */
    IO_ICR[8].byte = 30 ;                           /* 荞݂̗D惌x */
    IO_TMRLR0 = TIMER_PERIOD * MICRO_TICK - 1 ;     /* [hl           */
    timer_lo = TIMER_PERIOD * MICRO_TICK - 1 ;
    timer_hi = 0 ;
#else
    modFR60_timflag = 0 ;
#endif
}

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       ^C}nh
 * @par     
 *              ^C}荞݂Ƃ̃nhłB
 *              ԒPʂ SŁARQrbgłB
 *              OoX20MHẑƂA5mSPʂŃ^C}荞݂͔܂B
 */

__interrupt void 
mod_timer_handler( void )
{
    timer_hi++ ;
    IO_TMCSR0.bit.UF = 0 ;
}

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       ^C}vJn
 * @par     
 *              ^C}vJn܂B
 *              {֐́Aj^fobKQƂ܂B
 *              modFR60_timflagOFF̂ƂɏsȂꍇ́Ã[`Ŕ肵ĂB
 * @par     ӎF
 *              ̃[`́AR0WX^ȊÕWX^ۑKv܂B
 *              āALqꍇ́AAZuŋLqĂB
 *
 */

/*
 *  F
 *              void
 *              modFR60_timer_start( void )
 *              {
 *                  timer_hi = 0 ;
 *                  IO_TMCSR0.hword = RELD | INTE | CNTE | TRG ;
 *              }
 */

#ifdef USE_MOD_TIMER

#pragma asm

#define RELD    0x0010
#define INTE    0x0008
#define CNTE    0x0002
#define TRG     0x0001

        .global     _modFR60_timer_start
_modFR60_timer_start:
        stm         (r13)
        ldi         #0, r0
        ldi:32      #_timer_hi, r13
        sth         r0, @r13
        ldi         #RELD | INTE | CNTE | TRG, r13
        dmovh       r13, @_IO_TMCSR0
        ldm         (r13)
        ret
#pragma endasm

#else

void modFR60_timer_start( void ) { }

#endif


/*------------------------------------------------------------------------------------------*/
/**
 * @brief       ^C}vI
 * @par     
 *              ^C}v~܂B
 *              {֐́Aj^fobKQƂ܂B
 *              modFR60_timflagOFF̂ƂɏsȂꍇ́Ã[`Ŕ肵ĂB
 * @par     ӎF
 *              ̃[`́AR0WX^ȊÕWX^ۑKv܂B
 *              āALqꍇ́AAZuŋLqĂB
 */

/*
 *  F
 *              void
 *              modFR60_timer_stop( void )
 *              {
 *                  IO_TMCSR0.hword = 0 ;
 *                  timer_lo = IO_TMR0 ;
 *              }
 */

#ifdef USE_MOD_TIMER

#pragma asm

        .global _modFR60_timer_stop
_modFR60_timer_stop:
        stm         (r13)
        ldi         #0, r13
        dmovh       r13, @_IO_TMCSR0
        dmovh       @_IO_TMR0, r13
        ldi:32      #_timer_lo, r0
        sth         r13, @r0
        ldm         (r13)
        ret

#pragma endasm

#else

void modFR60_timer_stop( void ) { }

#endif

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       ^C}vlǂݏo
 * @param[in]   last    Ō̎s̎Ԃi[ϐւ̃|C^B
 * @param[in]   add     vl̗݌vi[Ăϐւ̃|C^B
 * @param[out]  *last   vʁBPʂ̓SB
 * @param[out]  *add    vl̗݌vB
 * @par     
 *              ^C}vlǂݏo܂B
 *              x̓SłB
 *              {֐́Aj^fobKQƂ܂B
 *              modFR60_timflagOFF̂ƂɏsȂꍇ́Ã[`Ŕ肵ĂB
 * @par     vI[owbh
 *              vAьvAvʂɂ͈ȉ̃I[owbh܂B
 *                  - 5ms PʂɎs^C}荞ݏ
 *                  - v́AReLXgޔ
 */

void
modFR60_timer_read
( 
    ULONG *last, 
    ULONG *add 
)
{
#ifdef USE_MOD_TIMER
    ULONG lo  = ( TIMER_PERIOD * MICRO_TICK - 1 ) - timer_lo ;
    ULONG t   =  timer_hi * TIMER_PERIOD + lo / MICRO_TICK ;
    *last = t ;
    *add += t ;
    timer_lo = TIMER_PERIOD * MICRO_TICK - 1 ;
    timer_hi = 0 ;
#endif
}

/****************
 * A{[g *
 ****************/

/*------------------------------------------------------------------------------------------*/
/**
 * @brief       A{[gṽNA
 * @par     
 *              A{[gvNA܂B
 *              {֐́AA{[gvNA邽߂ɁAj^fobKQƂ܂B
 *
 */

void
modFR60_abort_clear( void )
{
}


