/* MB91FV310A Port Initialize */

#include "_fr.h"
#include "extern.h"

void PORT_init(void)
{
	/* P36 : UDP Pullup control */
	IO_PDR3.bit.P36 = 1; /* Pullup off */
	IO_PORT.IO_DDR3.bit.P36 = 1; /* output */

	/* P35 : LED */
	IO_PDR3.bit.P35 = 1; /* LED off */
	IO_PORT.IO_DDR3.bit.P35 = 1; /* output */
}

void UDP_Pullup_on(void)
{
	IO_PDR3.bit.P36 = 0; /* Pullup on */
}

void UDP_Pullup_off(void)
{
	IO_PDR3.bit.P36 = 1; /* Pullup off */
}

void LED_on(void)
{
	IO_PDR3.bit.P35 = 0; /* LED on */
}

void LED_off(void)
{
	IO_PDR3.bit.P35 = 1; /* LED off */
}
