#pragma once
/****************************************************************
 * FR60 family Monitor Debugger                                 *
 * ALL RIGHTS RESERVED, COPYRIGHT(C) FUJITSU LIMITED 2007       *
 * LICENCED MATERIAL - PROGRAM PROPERTY OF FUJITSU LIMITED      *
 ****************************************************************/
/**
 * @file        modFR60.h
 * @brief       j^fobK HAL
 * @par 
 *      FR60t@~j^fobKgݍݗp̃wb_t@CłB
 *
 */

extern __interrupt void modFR60_inte_handler( void ) ;
extern __interrupt void modFR60_trace_handler( void ) ;
extern __interrupt void modFR60_reserved_handler( void ) ;
extern __interrupt void modFR60_abort_handler( void ) ;
extern __interrupt void modFR60_interrupt_handler( void ) ;
extern __interrupt void modFR60_coprocessor_error_trap_handler( void ) ;
extern __interrupt void modFR60_coprocessor_absence_exception_handler( void ) ;
extern __interrupt void modFR60_reserved_instruction_exception_handler( void ) ;
extern __interrupt void modFR60_hardware_break( void ) ;
extern __interrupt void modFR60_software_break( void ) ;

extern  void    modFR60_putchr(unsigned char) ;
extern  int     modFR60_getchr(unsigned char *) ;
extern  void    modFR60_timer_start( void ) ;
extern  void    modFR60_timer_stop( void ) ;
extern  void    modFR60_timer_read( unsigned long *last, unsigned long *add ) ;
extern  void    modFR60_abort_clear( void ) ;

extern unsigned char modFR60_timflag ;
extern unsigned char modFR60_sbrkflag ;

